<template>
  <div v-if="showNumberPriceSelectionForm">
    <v-list v-for="(brandAndStore,brandAndStoreIndex) in brandAndStoreList" :key="brandAndStore.shopName" style="background:transparent">
      <div style="padding-left:20px;">
        {{brandAndStore.shopName}}
      </div>
      <v-divider></v-divider>
      <v-list v-for="(brands, index) in brandAndStore.bransAndSize"
        :key="brands.brand"
        style="padding-left:0px;"
        class="defaultCardBackground">
        <div class="brandNameAndAddContainer">
          <div>
            {{brands.brand}}
          </div>
          <button @click="onAddMoreClick(brandAndStoreIndex,index)" class="addMoreSizesButton">
            Add
          </button>
        </div>
        <v-divider></v-divider>
        <form v-for="sizeNumberPrice in brands.sizes" :key="sizeNumberPrice.size"
          class="sizeNumberPriceInputsContainer"
          @submit.prevent="$v.$touch(); if($v.$error === false){onSubmit()};">
          <input class="numberPriceSizeInput"
            type="text"
            placeholder="Size"
            v-model="sizeNumberPrice.size"/>
          <input class="numberPriceSizeInput"
            type="number"
            placeholder="Number"
            v-model="sizeNumberPrice.number"/>
          <input class="numberPriceSizeInput"
            type="number"
            placeholder="Price"
            v-model="sizeNumberPrice.price"/>

        </form>
      </v-list>
      <v-divider></v-divider>
    </v-list>
    <span style="color:#FF6E40;padding-left:5%"
      v-if="formError">
      Form invalid: please fill out all the form fields
    </span>
    <v-btn depressed
      block
      color="darkSecondary"
      dark
      style="width:90%;margin:0 auto;margin-top:10px;"
      @click="onSubmit()">
      NEXT
    </v-btn>
    <br/>
  </div>
</template>
<script>
export default {
  name: 'SizeNumberPriceFormComonent',
  data: () => ({
    formError: false
  }),
  computed: {
    showNumberPriceSelectionForm () {
      return this.$store.state.itemRegistrationModule.brandFormValid
    },
    brandAndStoreList () {
      let generatedBrandData = []
      let storeData = this.$store.state.itemRegistrationModule.storeList
      storeData.forEach(element => {
        generatedBrandData.push({
          shopName: element.storeName,
          bransAndSize: element.brands.map(brandElement => {
            return {
              brand: brandElement,
              sizes: [
                {
                  size: null,
                  number: null,
                  price: null
                }
              ]
            }
          })
        })
      })
      return generatedBrandData
    }
  },
  methods: {
    onAddMoreClick (brandAndStoreIndex, brandIndex) {
      this.brandAndStoreList[brandAndStoreIndex].bransAndSize[brandIndex].sizes.push({
        size: null, number: null, price: null
      })
      this.$forceUpdate()
    },
    onSubmit () {
      this.brandAndStoreList.forEach(shopElement => {
        shopElement.bransAndSize.forEach(brandElement => {
          brandElement.sizes.forEach(sizeElement => {
            if (sizeElement.size === null || sizeElement.size === '' ||
            sizeElement.number === null || sizeElement.number === '' ||
            sizeElement.price === null || sizeElement.price === '') {
              this.formError = true
            } else {
              this.formError = false
            }
          })
        })
      })
      if (this.formError === false) {
        this.$store.commit('SIZE_REGISTRATION_FORM_COMPLETE', this.brandAndStoreList)
      }
    }
  }
}
</script>
<style scoped>
.sizeNumberPriceInputsContainer{
  display: flex;
  justify-content: space-around;
  margin-top: 10px;
}
.numberPriceSizeInput{
  border-style: groove;
  border: 1px solid #4D4D4D !important;
  width: 100px;
  float: left;
  display: block;
  position: relative;
  border-radius: 2px;
  padding: 5px 0px 5px 7px;
  height: 35px;
  margin-top:8px;
  outline: none;
}
.brandNameAndAddContainer{
  display: flex;
  justify-content: space-between;
  padding: 0px 10px;
}
.addMoreSizesButton{
  outline:none;
  font-size: 12px;
  padding: 5px 15px;
  border-radius: 5px;
  background-color: #2b8ba3;
  color: #ffffff;
  box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);
}
</style>
